<?php

namespace Drupal\migrate_wizard;

use Drupal\Core\Config\Config;
use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\Core\Database\Query\SelectInterface;
use Drupal\Core\Entity\EntityFieldManagerInterface;
use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\State\StateInterface;
use Drupal\migrate\Plugin\migrate\source\SqlBase;
use Drupal\migrate\Plugin\MigrationInterface;
use Drupal\migrate_wizard\Plugin\migrate\source\Wildcard;
use Drupal\mysql\Driver\Database\mysql\Select;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Base class for FieldType plugins.
 */
abstract class FieldTypeMWBase extends SqlBase {

  /**
   * Constructs a FieldTypeBaseMW object.
   *
   * @param array $configuration
   *   A configuration array containing information about the plugin instance.
   * @param string $plugin_id
   *   The plugin_id for the formatter.
   * @param mixed $plugin_definition
   *   The plugin implementation definition.
   * @param \Drupal\migrate_wizard\SourceDefinitionInterface $source_definition
   *   A definition of which sources there are that PluginMW plugins can use.
   */
    public function __construct(array $configuration, $plugin_id, $plugin_definition, MigrationInterface $migration, StateInterface $state) {
      parent::__construct($configuration, $plugin_id, $plugin_definition, $migration, $state);
    }

  /**
   * {@inheritdoc}
   */
  public static function insertBeforeKey($originalArray, $originalKey, $insertKey, $insertValue) {

    $newArray = [];
    $inserted = FALSE;
    foreach ($originalArray as $key => $value) {
      if (!$inserted && $key === $originalKey) {
        if(!isset($newArray[$insertKey])){
          $newArray[$insertKey] = [$insertValue];
        }else{
          $newArray[$insertKey][] = $insertValue;
        }
        $inserted = TRUE;
      }
      $newArray[$key] = $value;
    }
    return $newArray;
  }
  public function fields()
  {
    // TODO: Implement fields() method.
  }

  public function getIds()
  {
    // TODO: Implement getIds() method.
  }

  public function query()
  {
    // TODO: Implement query() method.
  }
}
