<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'generic_date' field type.
 *
 * @FieldType(
 *   id = "generic_date",
 * )
 */
class FieldTypeMWGenericDate extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL) {


    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => $origin_field . '_value',
      'method' => 'process',
    ];
    switch ($data_field['destiny']){
      case 'created':
        $array_config[$data_field['destiny']][] = [
          'plugin' => 'format_date',
          'from_format' => 'Y-m-d\TH:i:s',
          'to_format' => 'U',
        ];
        break;
      case 'date':
        $array_config[$data_field['destiny']][] = [
          'plugin' => 'substr',
          'start' => 0,
          'length' => 10,
        ];
        break;
    }

    if(!$field_collection){
      $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    }else{
      foreach($array_config[$data_field['destiny']] as $value){
        $wildcard_yml_config['process'] = parent::insertBeforeKey($wildcard_yml_config['process'], $field_collection, $data_field['destiny'], $value);
      }
    }



//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => $origin_field . '_value',
//      'method' => 'process',
//    ];
//
//    switch ($data_field['destiny']){
//      case 'created':
//        $wildcard_yml_config['process'][$data_field['destiny']][] = [
//          'plugin' => 'format_date',
//          'from_format' => 'Y-m-d\TH:i:s',
//          'to_format' => 'U',
//        ];
//        break;
//      case 'date':
//        $wildcard_yml_config['process'][$data_field['destiny']][] = [
//          'plugin' => 'substr',
//          'start' => 0,
//          'length' => 10,
//        ];
//        break;
//    }
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation, $field_collection = NULL) {

    $base_field = str_replace('field_data_', '', $table);

    if($field_collection == NULL){
      $wildcard->query->leftJoin($table, $alias, "{$wildcard->getValue('leftJoinTable')} = $alias.entity_id AND $alias.entity_type = '{$wildcard->getValue('entityType')}' AND $alias.bundle = '{$wildcard->getValue('bundle')}'");
    }else{
      $wildcard->query->leftJoin($table, $alias, "{$field_collection['left_join_table']} = $alias.entity_id AND $alias.entity_type = 'field_collection_item' AND $alias.bundle = '{$field_collection['bundle']}'");
    }

    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT CONCAT (COALESCE($alias.{$base_field}_value, '')) ORDER BY $alias.delta ASC SEPARATOR '|')", $base_field.'_value', []);
  }
}
