<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'range' field type.
 *
 * @FieldType(
 *   id = "range",
 * )
 */
class FieldTypeMWGenericRange extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL) {


    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => [$origin_field . '_from', $origin_field . '_to'],
      'method' => 'process',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'format_range_explode',
    ];

    if(!$field_collection){
      $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    }else{
      foreach($array_config[$data_field['destiny']] as $value){
        $wildcard_yml_config['process'] = parent::insertBeforeKey($wildcard_yml_config['process'], $field_collection, $data_field['destiny'], $value);
      }
    }


//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => [$origin_field . '_from', $origin_field . '_to'],
//      'method' => 'process',
//    ];
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'format_range_explode',
//    ];
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation, $field_collection = NULL) {

    $base_field = str_replace('field_data_', '', $table);

    if($field_collection == NULL){
      $wildcard->query->leftJoin($table, $alias, "{$wildcard->getValue('leftJoinTable')} = $alias.entity_id AND $alias.entity_type = '{$wildcard->getValue('entityType')}' AND $alias.bundle = '{$wildcard->getValue('bundle')}'");
    }else{
      $wildcard->query->leftJoin($table, $alias, "{$field_collection['left_join_table']} = $alias.entity_id AND $alias.entity_type = 'field_collection_item' AND $alias.bundle = '{$field_collection['bundle']}'");
    }

    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT CONCAT (COALESCE({$base_field}_from, '')) ORDER BY $alias.delta ASC SEPARATOR '||')", $base_field.'_from', []);
    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT CONCAT (COALESCE({$base_field}_to, '')) ORDER BY $alias.delta ASC SEPARATOR '||')", $base_field.'_to', []);
  }
}
