<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'generic_reference' field type.
 *
 * @FieldType(
 *   id = "generic_reference",
 * )
 */
class FieldTypeMWGenericReference extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL) {

    switch($data_field['type']){
      case 'taxonomy_term_reference':
        $suffix = '_tid';
        break;
      case 'node_reference':
        $suffix = '_nid';
        break;
      default:
        $suffix = '_target_id';
        break;
    }

    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => $origin_field . $suffix,
      'method' => 'process',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'explode',
      'method' => 'process',
      'delimiter' => ',',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'migration_lookup',
      'migration' => $data_field["migration_lookup"],
      'no_stub' => TRUE,
    ];

    if(!$field_collection){
      $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    }else{
      foreach($array_config[$data_field['destiny']] as $value){
        $wildcard_yml_config['process'] = parent::insertBeforeKey($wildcard_yml_config['process'], $field_collection, $data_field['destiny'], $value);
      }
    }

    foreach ($data_field['dependencies'] as $dependency) {
      if (!in_array($dependency, $wildcard_yml_config['migration_dependencies']['required']) && $dependency != $wildcard_yml_config['id']) {
        $wildcard_yml_config['migration_dependencies']['required'][] = $dependency;
      }
    }





//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => $origin_field . $suffix,
//      'method' => 'process',
//    ];
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'explode',
//      'method' => 'process',
//      'delimiter' => ',',
//    ];
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'migration_lookup',
//      'migration' => $data_field["migration_lookup"],
//      'no_stub' => TRUE,
//    ];
//
//    foreach ($data_field['dependencies'] as $dependency) {
//      if (!in_array($dependency, $wildcard_yml_config['migration_dependencies']['required']) && $dependency != $wildcard_yml_config['id']) {
//        $wildcard_yml_config['migration_dependencies']['required'][] = $dependency;
//      }
//    }
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation, $field_collection = NULL) {

    switch($data_field['type']){
      case 'taxonomy_term_reference':
        $suffix = '_tid';
        break;
      case 'node_reference':
        $suffix = '_nid';
        break;
      default:
        $suffix = '_target_id';
        break;
    }
    $base_field = str_replace('field_data_', '', $table);

    if($field_collection == NULL){
      $wildcard->query->leftJoin($table, $alias, "{$wildcard->getValue('leftJoinTable')} = $alias.entity_id AND $alias.entity_type = '{$wildcard->getValue('entityType')}' AND $alias.bundle = '{$wildcard->getValue('bundle')}'");
    }else{
      $wildcard->query->leftJoin($table, $alias, "{$field_collection['left_join_table']} = $alias.entity_id AND $alias.entity_type = 'field_collection_item' AND $alias.bundle = '{$field_collection['bundle']}'");
    }

    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT COALESCE({$base_field}{$suffix}, '') ORDER BY $alias.delta ASC SEPARATOR ',')", $base_field.$suffix, []);

  }

}
