<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'generic_text_long' field type.
 *
 * @FieldType(
 *   id = "generic_text_long",
 * )
 */
class FieldTypeMWGenericTextLong extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL) {

//    if ($data_field['destiny'] == 'description' && $wildcard_yml_config["destination"]["plugin"] == 'entity:taxonomy_term') {
//      $array_config[$data_field['destiny'] . '/value'][0]['source'] = $origin_field . '_value';
//    }

    $array_config['pseudo_'.$data_field['destiny'] . '_format'][] = [
      'source' => $origin_field . '_format',
      'plugin' => 'explode',
      'method' => 'process',
      'delimiter' => '||',
    ];
    $array_config['pseudo_'.$data_field['destiny'] . '_format'][] = [
      'plugin' => 'static_map',
      'map' => $config->get('origin_formats'),
      'default_value' => 'full_html',
    ];

    $array_config['pseudo_'.$data_field['destiny'] . '_value'][] = [
      'plugin' => 'skip_on_empty',
      'source' => $origin_field . '_value',
      'method' => 'process',
    ];
    $array_config['pseudo_'.$data_field['destiny'] . '_value'][] = [
      'plugin' => 'explode',
      'method' => 'process',
      'delimiter' => '||',
    ];
    $array_config['pseudo_'.$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => ['@pseudo_'.$data_field['destiny'] . '_value', '@pseudo_'.$data_field['destiny'] . '_format'],
      'method' => 'process',
    ];

    $array_config['pseudo_'.$data_field['destiny']][] = [
      'plugin' => 'text_long_with_format',
    ];

    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => '@pseudo_'.$data_field['destiny'],
      'method' => 'process'
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'sub_process',
      'method' => 'process',
      'process' => ['value' => 'value', 'format' => 'format'],
    ];

    if(!$field_collection){
      $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    }else{
      foreach($array_config[$data_field['destiny']] as $value){
        $wildcard_yml_config['process'] = parent::insertBeforeKey($wildcard_yml_config['process'], $field_collection, $data_field['destiny'], $value);
      }
    }

//    if ($data_field['destiny'] == 'description' && $wildcard_yml_config["destination"]["plugin"] == 'entity:taxonomy_term') {
//      $wildcard_yml_config['process'][$data_field['destiny'] . '/value'][0]['source'] = $origin_field . '_value';
//    }
//
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny'] . '_format'][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => $origin_field . '_format',
//      'method' => 'process',
//    ];
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny'] . '_format'][] = [
//      'plugin' => 'explode',
//      'method' => 'process',
//      'delimiter' => '||',
//    ];
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny'] . '_format'][] = [
//      'plugin' => 'static_map',
//      'map' => $config->get('origin_formats'),
//      'default_value' => 'full_html',
//    ];
//
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny'] . '_value'][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => $origin_field . '_value',
//      'method' => 'process',
//    ];
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny'] . '_value'][] = [
//      'plugin' => 'explode',
//      'method' => 'process',
//      'delimiter' => '||',
//    ];
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => ['@pseudo_'.$data_field['destiny'] . '_value', '@pseudo_'.$data_field['destiny'] . '_format'],
//      'method' => 'process',
//    ];
//
//    $wildcard_yml_config['process']['pseudo_'.$data_field['destiny']][] = [
//      'plugin' => 'text_long_with_format',
//    ];
//
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => '@pseudo_'.$data_field['destiny'],
//      'method' => 'process'
//    ];
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'sub_process',
//      'method' => 'process',
//      'process' => ['value' => 'value', 'format' => 'format'],
//    ];
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation, $field_collection = NULL) {

    $base_field = str_replace('field_data_', '', $table);

    if($field_collection == NULL){
      $wildcard->query->leftJoin($table, $alias, "{$wildcard->getValue('leftJoinTable')} = $alias.entity_id AND $alias.entity_type = '{$wildcard->getValue('entityType')}' AND $alias.bundle = '{$wildcard->getValue('bundle')}'");
    }else{
      $wildcard->query->leftJoin($table, $alias, "{$field_collection['left_join_table']} = $alias.entity_id AND $alias.entity_type = 'field_collection_item' AND $alias.bundle = '{$field_collection['bundle']}'");
    }

    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT COALESCE($alias.{$base_field}_value, '') ORDER BY $alias.delta ASC  SEPARATOR '||')", $base_field.'_value', []);
    $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT COALESCE($alias.{$base_field}_format, '') ORDER BY $alias.delta ASC  SEPARATOR '||')", $base_field.'_format', []);

  }

}
