<?php

namespace Drupal\migrate_wizard\Plugin\FieldTypeMW;

use Drupal\field\Entity\FieldStorageConfig;
use Drupal\migrate_wizard\FieldTypeMWBase;

/**
 * Provides 'geofield' field type.
 *
 * @FieldType(
 *   id = "geofield",
 * )
 */
class FieldTypeMWGeofield extends FieldTypeMWBase {

  public static function getMigrationConfig(&$wildcard_yml_config, $origin_field, $data_field, $type_source, $config, $entityFieldManager, $fieldTypeMWManager, $field_collection = NULL) {

    $array_config[$data_field['destiny']][] = [
      'plugin' => 'skip_on_empty',
      'source' => $origin_field . '_geohash',
      'method' => 'process',
    ];
    $array_config[$data_field['destiny']][] = [
      'plugin' => 'geofield_explode',
      'source' => [
        $origin_field . '_lat',
        $origin_field . '_lon',
        $origin_field . '_left',
        $origin_field . '_top',
        $origin_field . '_right',
        $origin_field . '_bottom',
        $origin_field . '_geohash',
      ],
    ];

    if(!$field_collection){
      $wildcard_yml_config['process'] = array_merge($wildcard_yml_config['process'], $array_config);
    }else{
      foreach($array_config[$data_field['destiny']] as $value){
        $wildcard_yml_config['process'] = parent::insertBeforeKey($wildcard_yml_config['process'], $field_collection, $data_field['destiny'], $value);
      }
    }


//
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'skip_on_empty',
//      'source' => [
//        $origin_field . '_lat',
//        $origin_field . '_lon',
//        $origin_field . '_left',
//        $origin_field . '_top',
//        $origin_field . '_right',
//        $origin_field . '_bottom',
//        $origin_field . '_geohash',
//      ],
//      'method' => 'process',
//    ];
//    $wildcard_yml_config['process'][$data_field['destiny']][] = [
//      'plugin' => 'geofield_explode',
//    ];
  }

  public function addQueryByType($alias, $table, $data_field, $wildcard, $translation) {

    $base_field = str_replace('field_data_', '', $table);
    $fields = [
      $base_field . '_lat',
      $base_field . '_lon',
      $base_field . '_left',
      $base_field . '_top',
      $base_field . '_right',
      $base_field . '_bottom',
      $base_field . '_geohash',
    ];
    $wildcard->query->leftJoin($table, $alias, "{$wildcard->getValue('leftJoinTable')} = $alias.entity_id AND $alias.entity_type = '{$wildcard->getValue('entityType')}' AND $alias.bundle = '{$wildcard->getValue('bundle')}'");
    foreach ($fields as $field) {
      $wildcard->query->addExpression("GROUP_CONCAT(DISTINCT CONCAT (COALESCE($alias.{$field}, '')) ORDER BY $alias.delta ASC SEPARATOR '||')", $field , []);
    }
  }

}
