<?php

namespace Drupal\migrate_wizard\Plugin\migrate\process;

use Drupal\media\Entity\Media;
use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\Row;
use Drupal\paragraphs\Entity\Paragraph;
use Drupal\Core\Entity\EntityFieldManagerInterface;


/**
 * Create media.
 *
 * @MigrateProcessPlugin(
 *   id = "create_paragraph_entity"
 * )
 */
class CreateParagraphEntity extends ProcessPluginBase {

  /**
   * {@inheritdoc}
   */
  protected $config;

  /**
   * {@inheritdoc}
   */
  protected $migrationUrlFilesProd;

  /**
   * {@inheritdoc}
   */
  protected $fileSystem;

  /**
   * {@inheritdoc}
   */
  protected $entityManager;

  /**
   * {@inheritdoc}
   */
  protected $entityFieldManager;

  /**
   * {@inheritdoc}
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {
    $this->config = \Drupal::configFactory()->getEditable('migrate_wizard.settings');


//    $resultados[] = [
//        'paragraph_type' => $this->configuration["bundle"],
//        'fields' => [
//          'field_large_text' => trim($actual_texto_primeralinea),
//          'field_view_mode' => 'default',
//        ]
//      ];
//      foreach($resultados as $key => $resultado){
//        $new_values[] = $this->createParagraph($resultado);
//      }

    $this->entityManager = \Drupal::service('entity_type.manager');
    $this->entityFieldManager = \Drupal::service('entity_field.manager');

    $base_fields = $this->entityFieldManager->getFieldDefinitions('paragraph', null);
    $paragraph_fields = $this->entityFieldManager->getFieldDefinitions('paragraph', $this->configuration['bundle']);

    //subtract arrays
    $paragraph_fields = array_diff_key($paragraph_fields, $base_fields);


    $array_creation_paragraph = ['paragraph_type' => $this->configuration["bundle"], 'fields' => []];
    $configuration_source = $this->configuration["source"];
    $key_int = 0;
    foreach($paragraph_fields as $field_name => $field_config){
      if($field_name == str_replace('@pseudo_', '', $configuration_source[$key_int])){
        $field_schema = $field_config->getFieldStorageDefinition()->getSchema();
        if(isset($value[$key_int])){
          foreach($value[$key_int] as $key_value => $value_value){
            if(is_array($value_value)){
              $array_value_value_array = [];
              foreach($value_value as $key_value_array => $value_value_array){
                if(isset($field_schema['columns'][$key_value_array])){
                  $array_value_value_array[$key_value_array] = $value_value_array;
                }
              }
              $array_creation_paragraph['fields'][$field_name][] = $array_value_value_array;
            }else{
              $array_creation_paragraph['fields'][$field_name][] = $value_value;
            }
          }
        }
      }
      $key_int++;
    }

    $new_values[] = $this->createParagraph($array_creation_paragraph);
    return $new_values;
  }

  protected function createParagraph($array_creation_paragraph){

    $paragraph = Paragraph::create([
      'type' => $array_creation_paragraph['paragraph_type']
    ]);

    foreach($array_creation_paragraph['fields'] as $key => $value){
      $paragraph->set($key, $value);
    }
    $paragraph->save();
    return [$paragraph->id(), $paragraph->getRevisionId()];
  }

}
