<?php

namespace Drupal\migrate_wizard\Plugin\migrate\process;

use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\Row;

/**
 * Format date range explode.
 *
 * @MigrateProcessPlugin(
 *   id = "format_date_range_explode"
 * )
 */
class FormatDateRangeExplode extends ProcessPluginBase {

  /**
   * {@inheritdoc}
   */
  protected $config;

  /**
   * {@inheritdoc}
   */
  protected $fileSystem;

  /**
   * {@inheritdoc}
   */
  protected $entityManager;

  /**
   * {@inheritdoc}
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {
    $values = explode('||', $value[0]);
    $values2 = explode('||', $value[1]);
    $new_value = [];
    foreach ($values as $key => $value) {
      $new_value[] = [
        'value' => $this->transformDate($value),
        'end_value' => $this->transformDate($values2[$key]),
      ];
    }
    return $new_value;
  }

  /**
   * {@inheritdoc}
   */
  private function transformDate($value) {
    $date = new \DateTime($value);
    return $date->format('Y-m-d');
  }

}
