<?php

namespace Drupal\migrate_wizard\Plugin\migrate\process;

use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\Row;

/**
 * Geofield explode.
 *
 * @MigrateProcessPlugin(
 *   id = "geofield_explode"
 * )
 */
class GeofieldExplode extends ProcessPluginBase {

  /**
   * {@inheritdoc}
   */
  protected $config;

  /**
   * {@inheritdoc}
   */
  protected $fileSystem;

  /**
   * {@inheritdoc}
   */
  protected $entityManager;

  /**
   * {@inheritdoc}
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {

    $lats = explode('||', $value[0]);
    $lons = explode('||', $value[1]);
    $lefts = explode('||', $value[2]);
    $tops = explode('||', $value[3]);
    $rights = explode('||', $value[4]);
    $bottoms = explode('||', $value[5]);
    $geohash = explode('||', $value[6]);
    $new_value = [];
    for($i=0; $i < count($lats); $i++) {
      $point = 'POINT (' . $lons[$i] . ' ' . $lats[$i] . ')';
      $new_value[] = [
        'value' => $point,
        'geo_type' => 'Point',
        'lat' => $lats[$i],
        'lon' => $lons[$i],
        'left' => $lefts[$i],
        'top' => $tops[$i],
        'right' => $rights[$i],
        'bottom' => $bottoms[$i],
        'geohash' => $geohash[$i],
      ];
    }
    return $new_value;
  }

}
